﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleGame
{
    class Hospital
    {
        private int healRate;
        private int goldRate;
        private int upgradeCost;
        private DateTime lastHeal = DateTime.Now;

        public Hospital()
        {
            healRate = 5;
            goldRate = 5;
            upgradeCost = 50;
        }

        public void Update(Player player)
        {
            if ((DateTime.Now - lastHeal).TotalMilliseconds > 1000)
            {
                if (player.IsInjured() && player.WithdrawGold(goldRate))
                {
                    Game.Log.Add(String.Format("Player {0} healed in hospital for {1} gold and {2} health.", player.GetName(), goldRate, healRate));
                    player.Heal(healRate);
                    lastHeal = DateTime.Now;
                }
            }
        }

        public void Upgrade(Player player)
        {
            if (player.IsInHospital())
            {
                if (player.WithdrawGold(upgradeCost))
                {
                    Game.Log.Add(String.Format("Player {0} upgraded hospital.", player.GetName()));
                    healRate += 5;
                }
                else
                {
                    Game.Log.Add(String.Format("Player {0} has not enough ({1}) gold for upgrade.", player.GetName(), upgradeCost));
                }
            }
            else
            {
                Game.Log.Add("Player can not upgrade hospital, if he is not in hospital.");
            }
        }

        public void Draw()
        {
            Console.WriteLine("Hospital state:");
            Console.WriteLine("Healing {0} health for {1} gold.", healRate, goldRate);
        }
    }
}
